package SAXWeb::MachinePages;

use strict;

use Apache::Constants;
use XML::SAX::Machines qw( :all );
use XML::Filter::XSLT;
use XML::SAX::Writer;

sub handler {
  my $r = shift;
  
  my @filters;
  
  if ( defined( $r->dir_config('MachineFilters') ) ) {
      my @widgets = split /\s+/, $r->dir_config('MachineFilters');
      my $m = Pipeline( @widgets );
      push @filters, $m;
  }
   
  if ( defined( $r->dir_config('MachineStyles') ) ) {
      my @stylesheets =  split /\s+/, $r->dir_config('MachineStyles');
      foreach my $style ( @stylesheets ) {
          my $xsl_filter =  XML::Filter::XSLT->new();
          $xsl_filter->set_stylesheet_uri( $style ); 
          push @filters, $xsl_filter;
      }
  }
   
  my $output = '';
  my $writer = XML::SAX::Writer->new( Output => \$output );
    my $m = Pipeline(
        @filters,
        $writer  
    );
    $m->parse_uri(  $r->filename );
    
    $r->content_type('text/html');
    $r->send_http_header;
    $r->print( $output );
    return OK;
}
 
1;
